/* -*- MaTX -*-
 *
 * tmd00007.h: TMD No. tmd00007 ľ졼ηΩҤΥǥ
 *                               إåե
 *
 *  Originally written by KIYOTA Hiromitsu <1999/01/19>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00007.h,v 1.4 1999/05/31 03:32:57 kiyota Exp $
 */

#ifndef _TMD00007_H
#define _TMD00007_H

#ifdef TMD_USER_H
#include TMD_USER_H
#endif /* TMD_USER_H */

#ifdef TMD00007_USER_H
#include TMD00007_USER_H
#endif /* TMD00007_USER_H */

#ifndef TMD00007_MM
#define TMD00007_MM "tmd00007.mm"
#endif /* !TMD00007_MM */

#ifdef TMD_ENABLE_PACKAGE
#ifdef TMD_ANSI
#define tmd00007(var) _tmd00007_ ## var
#else /* ! TMD_ANSI */
#define tmd00007(var) _tmd00007_/**/var
#endif /* TMD_ANSI */
#else /* ! TMD_ENABLE_PACKAGE */
#define tmd00007(var) var
#endif /* TMD_ENABLE_PACKAGE */

#ifndef TMD_EXTERN
#define TMD_EXTERN
#endif /* ! TMD_EXTERN */

// ǥξ(x)(u)(y)μο
#define TMD00007_DIM_STATE 8
#define TMD00007_DIM_INPUT 2
#define TMD00007_DIM_OUTPUT 4
#define TMD00007_DIM_ALL_IOS (TMD00007_DIM_INPUT+TMD00007_DIM_OUTPUT)

// ǥξ֡ξ֡ϤڤФԤʤޥ(ؿ)
#define chop_state_tmd00007(xx) [xx(1:TMD00007_DIM_STATE)]
#define chop_other_state_tmd00007(xx) [xx(TMD00007_DIM_STATE+1:)]
#define chop_input_tmd00007(uu) [uu(1:TMD00007_DIM_INPUT)]

// ǥʪѥ᡼
TMD_EXTERN Real tmd00007(M1), tmd00007(M2), tmd00007(mu1), tmd00007(mu2);
TMD_EXTERN Real tmd00007(m1), tmd00007(m2), tmd00007(I1), tmd00007(I2);
TMD_EXTERN Real tmd00007(l1), tmd00007(l2), tmd00007(n1), tmd00007(n2);
TMD_EXTERN Real tmd00007(k), tmd00007(J), tmd00007(KT), tmd00007(KE);
TMD_EXTERN Real tmd00007(Ra), tmd00007(r);
TMD_EXTERN Real tmd00007(c11), tmd00007(c21), tmd00007(c12), tmd00007(c22);
TMD_EXTERN Real tmd00007(g);

// ֶɽηޥȥꥯ
TMD_EXTERN Matrix tmd00007(A1), tmd00007(A2), tmd00007(B), tmd00007(C);
TMD_EXTERN Matrix tmd00007(A), tmd00007(B0);

// ѥåե饰: 1 ǥ; 0 ǥȤ
#ifdef TMD_DISABLE_HALIST
#define TMD00007_DISABLE_HALIST
#endif /* TMD_DISABLE_HALIST */
#ifdef TMD00007_DISABLE_HALIST
TMD_EXTERN Integer tmd00007_flag;
#endif /* TMD00007_DISABLE_HALIST */

// ؿ
#if !defined(TMD_USER_MM) && !defined(TMD00007_USER_MM) || !defined(TMD_DIVIDED_COMPILE) && !defined(TMD00007_DIVIDED_COMPILE)
#include TMD00007_MM
#else /* !(!TMD_USER_MM && !TMD00007_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00007_DIVIDED_COMPILE) */
void init_tmd00007(/* linear_flag, params_flag, */ ...); // require TMD00007_MM;
Matrix diff_tmd00007(/* t, x, u */); // require TMD00007_MM;
Matrix output_tmd00007(/* t, x, u */); // require TMD00007_MM;
#endif /* !TMD_USER_MM && !TMD00007_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00007_DIVIDED_COMPILE */

#undef TMD_EXTERN
#endif /* ! _TMD00007_H */
